﻿Attention: By opening this site you consent, accept and agree to the [Terms](#terms) below

Attention: If you are using WooCommerce version 8.3 and above or using Cart and Checkout blocks instead of shortcodes you have to [revert to Cart and Checkout shortcodes](https://woo.com/document/cart-checkout-blocks-status/#section-6) for now to make SuchWOW Gateway visible at the checkout.

# SuchWOW Gateway for WooCommerce
Now WOW Meow accept Wownero payments in your WooCommerce store directly through your own private SuchWOW gateway.
SuchWOW Gateway is a WordPress plug-in that integrates Wownero as a payment method into your WooCommerce store. 

## SuchWOW Gateway Features
* Payment clearance by your private Wownero inter-dimensional bank daemon which is accessed by SuchWOW Gateway trough your own RPC instance of your wowlet
* Alternatively payment clearance can be done through block explorer using view key, by default - explorer.suchwow.xyz - the block explorer of the trusted meme authority suchwow.xyz
* Background payment validation
* Order status update through AJAX instead of Javascript page reloads
* Customers can pay with multiple transactions and are notified as soon as transactions hit the mempool
* Configurable block confirmations, from `0` for zero confirm to `60` for high ticket purchases
to your own wowlet via Wownero daemon
* Live Wownero price updates from TradeOgre.com every minute; total amount due is locked in after the order is placed for a configurable amount of time (default 60 minutes) so the price does not change after order has been made
* Hooks into emails, order confirmation page, customer order history page, and admin order details page
* View all payments received to your wallet with links to the blockchain explorer and associated orders
* Optionally display all prices on your store in terms of Wownero
* Shortcodes can be used to display Wownero exchange rate rate to USD or Wownero accepted badge.

Before activating your SuchWOW Gateway you will need
* WordPress website
* [WooCommerce plug-in for WordPress](https://wordpress.org/plugins/woocommerce/)
* [This SuchWOW Gateway plug-in](https://git.wownero.com/rapeafed/suchwow-gateway/archive/master.zip)
* BCMath extension for PHP is activated (it usually is)
* If you will be using block explorer clearance (easy and less private) then you will need [Wowlet](https://wowlet.app/download/) or [Wownero CLI Wallet](https://git.wownero.com/wownero/wownero/releases) to create wallet and get your address and viewkey 
* If you want to use your own daemon to clear transactions  (more private and slightly more complicated setup) then you will need [Wownero CLI Wallet](https://git.wownero.com/wownero/wownero/releases) downloaded and installed nearby or on the same server with WordPress. You will need wownerod (Wownero daemon) and wownero-wallet-rpc from the Wownero CLI Wallet package

## Installing the plugin

### Semi-Automatic Method
1. [Download SuchWOW Gateway plug-in zip file here](https://git.wownero.com/rapeafed/suchwow-gateway/archive/master.zip)
2. Open WordPress
3. Go “PlugIns” on the left side when you login to your WordPress as admin.
4. Click “Add new Plugin” on top
5. Click “Upload Plugin” on top
6. Choose file – zip file with SuchWOW Gateway plug in you downloaded
7. Click install now

If you are still reading this paragraph consider using Option 1 - default block explorer payment clearance using Wownero main address and viewkey for simplicity.
Automatic installation and updates are not available at this moment – check back for updates.

### Manual Method
1. [Download SuchWOW Gateway plugin from here](https://git.wownero.com/rapeafed/suchwow-gateway/archive/master.zip) or clone with `git clone https://git.wownero.com/rapeafed/suchwow-gateway`
2. Unzip or place the `suchwow-gateway` folder in the `wp-content/plugins` directory of
3. Activate "SuchWOW Gateway" in your WordPress admin/plugins dashboard.

4. It is highly recommended that you use native cronjobs instead of WordPress's "Poor Man's Cron" by adding `define('DISABLE_WP_CRON', true);` into your `wp-config.php` file and adding `* * * * * wget -q -O - https://yourstore.com/wp-cron.php?doing_wp_cron >/dev/null 2>&1` to your crontab.


## Option 1: Use your wallet address and viewkey

This is the easiest way to start accepting SuchWOW Gateway on your website. You'll need:

* Your Wownero wallet address starting with `Wo`
* Your wallet's secret viewkey

Then simply select the `viewkey` option in the settings page and paste your address and viewkey. You're all set!

Note on privacy: when transactions are validated with your private viewkey, your viewkey is sent to (but not stored on) explorer.suchwow.xyz over HTTPS. This could potentially allow an attacker to see your incoming, but not outgoing, transactions if they were to get his hands on your viewkey. Even if this were to happen, your funds would still be safe and it would be impossible for somebody to steal your money. For maximum privacy use Option 2 - your own `wownero-wallet-rpc` instance.

## Option 2: Using `wownero-wallet-rpc`- your own RPC instance of your wallet

The most secure way to use SuchWOW Gateway and accept Wownero payments on your website. You'll need:

* Root access to your webserver
* Latest [Wownero CLI Wallet Binaries](https://git.wownero.com/wownero/wownero/releases)

1. Downloading or compile the Wownero binaries on your server
2. Run the Wownero daemon and wowlet rpc instance one of the following ways:
	a. Install the [systemd unit files](https://git.wownero.com/rapeafed/suchwow-gateway/src/branch/master/assets/systemd-unit-files) - (make sure you check configuration there first)
		or
	b. Run `wownerod` and `wownero-wallet-rpc` with `screen` or `tmux`:
	Examples of Wownero daemon command line:
	When Wownero Daemon is on the same server:
	./wownerod local daemon
	When you are running Wownero Daemon on the other server (replace IP address):
	./wownerod --rpc-bind-ip 22.22.22.22 --confirm-external-bind

	Examples of wownero-wallet-rpc:
	Replace wowletfile with your wowlet file name and ip with ip address of rpc instance. For best security only run rpc instance locally.
	Add --rpc-bind-ip 127.0.0.1 --confirm-external-bind if RPC instance is on the other server
	Add --daemon-address node.suchwow.xyz:34568 to use remote daemon
	Add --log-level 4 for logging
	Add --prompt-for-password to ask for password

	./wownero-wallet-rpc --wallet-file ./wowletfile --password walletpassword --rpc-bind-port 14666 --disable-rpc-login 
	or
	./wownero-wallet-rpc --wallet-file ./wowletfile --rpc-bind-port 18666  --disable-rpc-login --prompt-for-password
	or
	./wownero-wallet-rpc --wallet-file ./wowletfile --rpc-bind-ip 22.22.22.22 --rpc-bind-port 18666 --confirm-external-bind --disable-rpc-login --password walletpassword --daemon-address node.suchwow.xyz:34568 --log-level 4

If for some reason can’t run wownerod (daemon) that you should be running anyway already - you can use a remote node with `wownero-wallet-rpc` by adding `--daemon-address node.suchwow.xyz:34568` to the `wownero-wallet-rpc.service` file.

!!!ATTENTION: using this option, while the most secure, requires you to run the Wownero wallet RPC program on your server. Best practice for this is to use a view-only wallet since otherwise your server would be running a hot-wallet and a security breach could allow hackers to empty your funds.

## SuchWOW Gateway Configuration

* `Enable / Disable` - Turn on or off SuchWOW gateway. (Default: Disable)
* `Title` - Name of the payment gateway as displayed to the customer. (Default: SuchWOW Gateway)
* `Discount for using Wownero` - Percentage discount applied to orders for paying with Wownero. Can also be negative to apply a surcharge. (Default: 0)
* `Order valid time` - Number of seconds after order is placed that the transaction must be seen in the mempool. (Default: 3600 [1 hour])
* `Number of confirmations` - Number of confirmations the transaction must receive before the order is marked as complete. Use `0` for nearly instant confirmation. (Default: 0)
* `Confirmation Type` - Confirm transactions with either your viewkey, or by using `wownero-wallet-rpc`. (Default: viewkey)
* `Wownero Address` (if confirmation type is viewkey) - Your public Wownero address starting with Wo. (No default)
* `Secret Viewkey` (if confirmation type is viewkey) - Your *private* viewkey (No default)
* `Wownero wallet RPC Host/IP` (if confirmation type is `wownero-wallet-rpc`) - IP address where the wallet rpc is running. It is highly discouraged to run the wallet anywhere other than the local server! (Default: 127.0.0.1)
* `Wownero wallet RPC port` (if confirmation type is `wownero-wallet-rpc`) - Port the wallet rpc is bound to with the `--rpc-bind-port` argument. (Default 14666)
* `Testnet` - Check this to change the blockchain explorer links to the testnet explorer. (Default: unchecked) This feature is not available at this moment.
* `SSL warnings` - Check this to silence SSL warnings. (Default: unchecked)
* `Show QR Code` - Show payment QR codes. (Default: unchecked)
* `Show Prices in Wownero` - Convert all prices on the frontend to Wownero. Experimental feature, not available in the card at this moment, only use if you do not accept any other payment option. (Default: unchecked)
* `Display Decimals` (if show prices in Wownero is enabled) - Number of decimals to round prices to on the frontend. The final order amount will not be rounded and will be displayed down to the nanowow. (Default: 12)


## Shortcodes

This plugin makes available two shortcodes that you can use in your theme.

#### Live price shortcode

This will display the price of Wownero in the selected currency. If no currency is provided, the store's default currency will be used.

```
[wownero-price]
[wownero-price currency="USD"]
[wownero-price currency="WOWNERO"]
```
Should display:
```
1 WOW = 123.68000 USD
1 WOW = 123.68000 USD
1 WOW = 1 WOWNERO
```


#### Wownero accepted here badge

This will display a badge showing that you accept Wownero-currency.

`[wownero-accepted-here]`

![Wownero Accepted Here](/assets/images/wownero-accepted-here.png?raw=true "Wownero Accepted Here")

## Donations
rapeafed
WW3BuWSj3ei2zzEho3VPBtC5cYqFbPL589SQ1NKUWCF46YU7NzSpW173umfjfX88Tj2BqkkCaLoicbYG5jJ3zyK91xT1uZyf5

## SuchWOW Gateway Support and Integration


## Credits
monero-integrations 
ryo-currency

## Terms
By opening this site you consent, accept and agree to the items 1 to 5 listed below that:
1. you and everyone else have no jurisdiction over rapeafed and any and all developers and users involved directly and indirectly in SuchWOW gateway and Wownero development and use
2. you act on your own free will and understand that code and safety instruction have been completed in a good faith to the best ability with quality of your experience and your safety in mind
3. you accept the license terms
4. you accept and agree that you receive no warrantees and guarantees expressed or implied including but not limited to the warranties of merchantability, fitness for a particular purpose and noninfrigement 
5. you have and will have no claims to and will indemnify and hold harmless rapeafed and any and all other developers and users of SuchWOW Gateway and Wownero against any and all direct, indirect and consequential damages
